// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: commonmodule/commonmodule.proto

package openfmb.commonmodule;

/**
 * <pre>
 * LN: Generic process I/O   Name: GGIO
 * </pre>
 *
 * Protobuf type {@code commonmodule.BooleanEventAndStatusGGIO}
 */
public final class BooleanEventAndStatusGGIO extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:commonmodule.BooleanEventAndStatusGGIO)
    BooleanEventAndStatusGGIOOrBuilder {
private static final long serialVersionUID = 0L;
  // Use BooleanEventAndStatusGGIO.newBuilder() to construct.
  private BooleanEventAndStatusGGIO(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private BooleanEventAndStatusGGIO() {
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(
      UnusedPrivateParameter unused) {
    return new BooleanEventAndStatusGGIO();
  }

  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_BooleanEventAndStatusGGIO_descriptor;
  }

  @java.lang.Override
  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_BooleanEventAndStatusGGIO_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            openfmb.commonmodule.BooleanEventAndStatusGGIO.class, openfmb.commonmodule.BooleanEventAndStatusGGIO.Builder.class);
  }

  public static final int LOGICALNODE_FIELD_NUMBER = 1;
  private openfmb.commonmodule.LogicalNode logicalNode_;
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.LogicalNode logicalNode = 1 [(.uml.option_parent_message) = true];</code>
   * @return Whether the logicalNode field is set.
   */
  @java.lang.Override
  public boolean hasLogicalNode() {
    return logicalNode_ != null;
  }
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.LogicalNode logicalNode = 1 [(.uml.option_parent_message) = true];</code>
   * @return The logicalNode.
   */
  @java.lang.Override
  public openfmb.commonmodule.LogicalNode getLogicalNode() {
    return logicalNode_ == null ? openfmb.commonmodule.LogicalNode.getDefaultInstance() : logicalNode_;
  }
  /**
   * <pre>
   * UML inherited base object
   * </pre>
   *
   * <code>.commonmodule.LogicalNode logicalNode = 1 [(.uml.option_parent_message) = true];</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.LogicalNodeOrBuilder getLogicalNodeOrBuilder() {
    return logicalNode_ == null ? openfmb.commonmodule.LogicalNode.getDefaultInstance() : logicalNode_;
  }

  public static final int IND_FIELD_NUMBER = 2;
  private openfmb.commonmodule.StatusSPS ind_;
  /**
   * <pre>
   * If true, indication &lt;i&gt;n&lt;/i&gt; is present.
   * </pre>
   *
   * <code>.commonmodule.StatusSPS Ind = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return Whether the ind field is set.
   */
  @java.lang.Override
  public boolean hasInd() {
    return ind_ != null;
  }
  /**
   * <pre>
   * If true, indication &lt;i&gt;n&lt;/i&gt; is present.
   * </pre>
   *
   * <code>.commonmodule.StatusSPS Ind = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   * @return The ind.
   */
  @java.lang.Override
  public openfmb.commonmodule.StatusSPS getInd() {
    return ind_ == null ? openfmb.commonmodule.StatusSPS.getDefaultInstance() : ind_;
  }
  /**
   * <pre>
   * If true, indication &lt;i&gt;n&lt;/i&gt; is present.
   * </pre>
   *
   * <code>.commonmodule.StatusSPS Ind = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.StatusSPSOrBuilder getIndOrBuilder() {
    return ind_ == null ? openfmb.commonmodule.StatusSPS.getDefaultInstance() : ind_;
  }

  public static final int PHASE_FIELD_NUMBER = 3;
  private openfmb.commonmodule.Optional_PhaseCodeKind phase_;
  /**
   * <pre>
   * Phase code
   * </pre>
   *
   * <code>.commonmodule.Optional_PhaseCodeKind Phase = 3;</code>
   * @return Whether the phase field is set.
   */
  @java.lang.Override
  public boolean hasPhase() {
    return phase_ != null;
  }
  /**
   * <pre>
   * Phase code
   * </pre>
   *
   * <code>.commonmodule.Optional_PhaseCodeKind Phase = 3;</code>
   * @return The phase.
   */
  @java.lang.Override
  public openfmb.commonmodule.Optional_PhaseCodeKind getPhase() {
    return phase_ == null ? openfmb.commonmodule.Optional_PhaseCodeKind.getDefaultInstance() : phase_;
  }
  /**
   * <pre>
   * Phase code
   * </pre>
   *
   * <code>.commonmodule.Optional_PhaseCodeKind Phase = 3;</code>
   */
  @java.lang.Override
  public openfmb.commonmodule.Optional_PhaseCodeKindOrBuilder getPhaseOrBuilder() {
    return phase_ == null ? openfmb.commonmodule.Optional_PhaseCodeKind.getDefaultInstance() : phase_;
  }

  private byte memoizedIsInitialized = -1;
  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    if (logicalNode_ != null) {
      output.writeMessage(1, getLogicalNode());
    }
    if (ind_ != null) {
      output.writeMessage(2, getInd());
    }
    if (phase_ != null) {
      output.writeMessage(3, getPhase());
    }
    getUnknownFields().writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    if (logicalNode_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(1, getLogicalNode());
    }
    if (ind_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(2, getInd());
    }
    if (phase_ != null) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(3, getPhase());
    }
    size += getUnknownFields().getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof openfmb.commonmodule.BooleanEventAndStatusGGIO)) {
      return super.equals(obj);
    }
    openfmb.commonmodule.BooleanEventAndStatusGGIO other = (openfmb.commonmodule.BooleanEventAndStatusGGIO) obj;

    if (hasLogicalNode() != other.hasLogicalNode()) return false;
    if (hasLogicalNode()) {
      if (!getLogicalNode()
          .equals(other.getLogicalNode())) return false;
    }
    if (hasInd() != other.hasInd()) return false;
    if (hasInd()) {
      if (!getInd()
          .equals(other.getInd())) return false;
    }
    if (hasPhase() != other.hasPhase()) return false;
    if (hasPhase()) {
      if (!getPhase()
          .equals(other.getPhase())) return false;
    }
    if (!getUnknownFields().equals(other.getUnknownFields())) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    if (hasLogicalNode()) {
      hash = (37 * hash) + LOGICALNODE_FIELD_NUMBER;
      hash = (53 * hash) + getLogicalNode().hashCode();
    }
    if (hasInd()) {
      hash = (37 * hash) + IND_FIELD_NUMBER;
      hash = (53 * hash) + getInd().hashCode();
    }
    if (hasPhase()) {
      hash = (37 * hash) + PHASE_FIELD_NUMBER;
      hash = (53 * hash) + getPhase().hashCode();
    }
    hash = (29 * hash) + getUnknownFields().hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static openfmb.commonmodule.BooleanEventAndStatusGGIO parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.commonmodule.BooleanEventAndStatusGGIO parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.commonmodule.BooleanEventAndStatusGGIO parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.commonmodule.BooleanEventAndStatusGGIO parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.commonmodule.BooleanEventAndStatusGGIO parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static openfmb.commonmodule.BooleanEventAndStatusGGIO parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static openfmb.commonmodule.BooleanEventAndStatusGGIO parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.commonmodule.BooleanEventAndStatusGGIO parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.commonmodule.BooleanEventAndStatusGGIO parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static openfmb.commonmodule.BooleanEventAndStatusGGIO parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static openfmb.commonmodule.BooleanEventAndStatusGGIO parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static openfmb.commonmodule.BooleanEventAndStatusGGIO parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(openfmb.commonmodule.BooleanEventAndStatusGGIO prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * <pre>
   * LN: Generic process I/O   Name: GGIO
   * </pre>
   *
   * Protobuf type {@code commonmodule.BooleanEventAndStatusGGIO}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:commonmodule.BooleanEventAndStatusGGIO)
      openfmb.commonmodule.BooleanEventAndStatusGGIOOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_BooleanEventAndStatusGGIO_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_BooleanEventAndStatusGGIO_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              openfmb.commonmodule.BooleanEventAndStatusGGIO.class, openfmb.commonmodule.BooleanEventAndStatusGGIO.Builder.class);
    }

    // Construct using openfmb.commonmodule.BooleanEventAndStatusGGIO.newBuilder()
    private Builder() {

    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);

    }
    @java.lang.Override
    public Builder clear() {
      super.clear();
      bitField0_ = 0;
      logicalNode_ = null;
      if (logicalNodeBuilder_ != null) {
        logicalNodeBuilder_.dispose();
        logicalNodeBuilder_ = null;
      }
      ind_ = null;
      if (indBuilder_ != null) {
        indBuilder_.dispose();
        indBuilder_ = null;
      }
      phase_ = null;
      if (phaseBuilder_ != null) {
        phaseBuilder_.dispose();
        phaseBuilder_ = null;
      }
      return this;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return openfmb.commonmodule.Commonmodule.internal_static_commonmodule_BooleanEventAndStatusGGIO_descriptor;
    }

    @java.lang.Override
    public openfmb.commonmodule.BooleanEventAndStatusGGIO getDefaultInstanceForType() {
      return openfmb.commonmodule.BooleanEventAndStatusGGIO.getDefaultInstance();
    }

    @java.lang.Override
    public openfmb.commonmodule.BooleanEventAndStatusGGIO build() {
      openfmb.commonmodule.BooleanEventAndStatusGGIO result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public openfmb.commonmodule.BooleanEventAndStatusGGIO buildPartial() {
      openfmb.commonmodule.BooleanEventAndStatusGGIO result = new openfmb.commonmodule.BooleanEventAndStatusGGIO(this);
      if (bitField0_ != 0) { buildPartial0(result); }
      onBuilt();
      return result;
    }

    private void buildPartial0(openfmb.commonmodule.BooleanEventAndStatusGGIO result) {
      int from_bitField0_ = bitField0_;
      if (((from_bitField0_ & 0x00000001) != 0)) {
        result.logicalNode_ = logicalNodeBuilder_ == null
            ? logicalNode_
            : logicalNodeBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000002) != 0)) {
        result.ind_ = indBuilder_ == null
            ? ind_
            : indBuilder_.build();
      }
      if (((from_bitField0_ & 0x00000004) != 0)) {
        result.phase_ = phaseBuilder_ == null
            ? phase_
            : phaseBuilder_.build();
      }
    }

    @java.lang.Override
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof openfmb.commonmodule.BooleanEventAndStatusGGIO) {
        return mergeFrom((openfmb.commonmodule.BooleanEventAndStatusGGIO)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(openfmb.commonmodule.BooleanEventAndStatusGGIO other) {
      if (other == openfmb.commonmodule.BooleanEventAndStatusGGIO.getDefaultInstance()) return this;
      if (other.hasLogicalNode()) {
        mergeLogicalNode(other.getLogicalNode());
      }
      if (other.hasInd()) {
        mergeInd(other.getInd());
      }
      if (other.hasPhase()) {
        mergePhase(other.getPhase());
      }
      this.mergeUnknownFields(other.getUnknownFields());
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10: {
              input.readMessage(
                  getLogicalNodeFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000001;
              break;
            } // case 10
            case 18: {
              input.readMessage(
                  getIndFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000002;
              break;
            } // case 18
            case 26: {
              input.readMessage(
                  getPhaseFieldBuilder().getBuilder(),
                  extensionRegistry);
              bitField0_ |= 0x00000004;
              break;
            } // case 26
            default: {
              if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                done = true; // was an endgroup tag
              }
              break;
            } // default:
          } // switch (tag)
        } // while (!done)
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.unwrapIOException();
      } finally {
        onChanged();
      } // finally
      return this;
    }
    private int bitField0_;

    private openfmb.commonmodule.LogicalNode logicalNode_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.LogicalNode, openfmb.commonmodule.LogicalNode.Builder, openfmb.commonmodule.LogicalNodeOrBuilder> logicalNodeBuilder_;
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNode logicalNode = 1 [(.uml.option_parent_message) = true];</code>
     * @return Whether the logicalNode field is set.
     */
    public boolean hasLogicalNode() {
      return ((bitField0_ & 0x00000001) != 0);
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNode logicalNode = 1 [(.uml.option_parent_message) = true];</code>
     * @return The logicalNode.
     */
    public openfmb.commonmodule.LogicalNode getLogicalNode() {
      if (logicalNodeBuilder_ == null) {
        return logicalNode_ == null ? openfmb.commonmodule.LogicalNode.getDefaultInstance() : logicalNode_;
      } else {
        return logicalNodeBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNode logicalNode = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder setLogicalNode(openfmb.commonmodule.LogicalNode value) {
      if (logicalNodeBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        logicalNode_ = value;
      } else {
        logicalNodeBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNode logicalNode = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder setLogicalNode(
        openfmb.commonmodule.LogicalNode.Builder builderForValue) {
      if (logicalNodeBuilder_ == null) {
        logicalNode_ = builderForValue.build();
      } else {
        logicalNodeBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNode logicalNode = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder mergeLogicalNode(openfmb.commonmodule.LogicalNode value) {
      if (logicalNodeBuilder_ == null) {
        if (((bitField0_ & 0x00000001) != 0) &&
          logicalNode_ != null &&
          logicalNode_ != openfmb.commonmodule.LogicalNode.getDefaultInstance()) {
          getLogicalNodeBuilder().mergeFrom(value);
        } else {
          logicalNode_ = value;
        }
      } else {
        logicalNodeBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000001;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNode logicalNode = 1 [(.uml.option_parent_message) = true];</code>
     */
    public Builder clearLogicalNode() {
      bitField0_ = (bitField0_ & ~0x00000001);
      logicalNode_ = null;
      if (logicalNodeBuilder_ != null) {
        logicalNodeBuilder_.dispose();
        logicalNodeBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNode logicalNode = 1 [(.uml.option_parent_message) = true];</code>
     */
    public openfmb.commonmodule.LogicalNode.Builder getLogicalNodeBuilder() {
      bitField0_ |= 0x00000001;
      onChanged();
      return getLogicalNodeFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNode logicalNode = 1 [(.uml.option_parent_message) = true];</code>
     */
    public openfmb.commonmodule.LogicalNodeOrBuilder getLogicalNodeOrBuilder() {
      if (logicalNodeBuilder_ != null) {
        return logicalNodeBuilder_.getMessageOrBuilder();
      } else {
        return logicalNode_ == null ?
            openfmb.commonmodule.LogicalNode.getDefaultInstance() : logicalNode_;
      }
    }
    /**
     * <pre>
     * UML inherited base object
     * </pre>
     *
     * <code>.commonmodule.LogicalNode logicalNode = 1 [(.uml.option_parent_message) = true];</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.LogicalNode, openfmb.commonmodule.LogicalNode.Builder, openfmb.commonmodule.LogicalNodeOrBuilder> 
        getLogicalNodeFieldBuilder() {
      if (logicalNodeBuilder_ == null) {
        logicalNodeBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.LogicalNode, openfmb.commonmodule.LogicalNode.Builder, openfmb.commonmodule.LogicalNodeOrBuilder>(
                getLogicalNode(),
                getParentForChildren(),
                isClean());
        logicalNode_ = null;
      }
      return logicalNodeBuilder_;
    }

    private openfmb.commonmodule.StatusSPS ind_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.StatusSPS, openfmb.commonmodule.StatusSPS.Builder, openfmb.commonmodule.StatusSPSOrBuilder> indBuilder_;
    /**
     * <pre>
     * If true, indication &lt;i&gt;n&lt;/i&gt; is present.
     * </pre>
     *
     * <code>.commonmodule.StatusSPS Ind = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return Whether the ind field is set.
     */
    public boolean hasInd() {
      return ((bitField0_ & 0x00000002) != 0);
    }
    /**
     * <pre>
     * If true, indication &lt;i&gt;n&lt;/i&gt; is present.
     * </pre>
     *
     * <code>.commonmodule.StatusSPS Ind = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     * @return The ind.
     */
    public openfmb.commonmodule.StatusSPS getInd() {
      if (indBuilder_ == null) {
        return ind_ == null ? openfmb.commonmodule.StatusSPS.getDefaultInstance() : ind_;
      } else {
        return indBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * If true, indication &lt;i&gt;n&lt;/i&gt; is present.
     * </pre>
     *
     * <code>.commonmodule.StatusSPS Ind = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder setInd(openfmb.commonmodule.StatusSPS value) {
      if (indBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ind_ = value;
      } else {
        indBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * If true, indication &lt;i&gt;n&lt;/i&gt; is present.
     * </pre>
     *
     * <code>.commonmodule.StatusSPS Ind = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder setInd(
        openfmb.commonmodule.StatusSPS.Builder builderForValue) {
      if (indBuilder_ == null) {
        ind_ = builderForValue.build();
      } else {
        indBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * If true, indication &lt;i&gt;n&lt;/i&gt; is present.
     * </pre>
     *
     * <code>.commonmodule.StatusSPS Ind = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder mergeInd(openfmb.commonmodule.StatusSPS value) {
      if (indBuilder_ == null) {
        if (((bitField0_ & 0x00000002) != 0) &&
          ind_ != null &&
          ind_ != openfmb.commonmodule.StatusSPS.getDefaultInstance()) {
          getIndBuilder().mergeFrom(value);
        } else {
          ind_ = value;
        }
      } else {
        indBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * If true, indication &lt;i&gt;n&lt;/i&gt; is present.
     * </pre>
     *
     * <code>.commonmodule.StatusSPS Ind = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public Builder clearInd() {
      bitField0_ = (bitField0_ & ~0x00000002);
      ind_ = null;
      if (indBuilder_ != null) {
        indBuilder_.dispose();
        indBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * If true, indication &lt;i&gt;n&lt;/i&gt; is present.
     * </pre>
     *
     * <code>.commonmodule.StatusSPS Ind = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.commonmodule.StatusSPS.Builder getIndBuilder() {
      bitField0_ |= 0x00000002;
      onChanged();
      return getIndFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * If true, indication &lt;i&gt;n&lt;/i&gt; is present.
     * </pre>
     *
     * <code>.commonmodule.StatusSPS Ind = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    public openfmb.commonmodule.StatusSPSOrBuilder getIndOrBuilder() {
      if (indBuilder_ != null) {
        return indBuilder_.getMessageOrBuilder();
      } else {
        return ind_ == null ?
            openfmb.commonmodule.StatusSPS.getDefaultInstance() : ind_;
      }
    }
    /**
     * <pre>
     * If true, indication &lt;i&gt;n&lt;/i&gt; is present.
     * </pre>
     *
     * <code>.commonmodule.StatusSPS Ind = 2 [(.uml.option_required_field) = true, (.uml.option_multiplicity_min) = 1];</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.StatusSPS, openfmb.commonmodule.StatusSPS.Builder, openfmb.commonmodule.StatusSPSOrBuilder> 
        getIndFieldBuilder() {
      if (indBuilder_ == null) {
        indBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.StatusSPS, openfmb.commonmodule.StatusSPS.Builder, openfmb.commonmodule.StatusSPSOrBuilder>(
                getInd(),
                getParentForChildren(),
                isClean());
        ind_ = null;
      }
      return indBuilder_;
    }

    private openfmb.commonmodule.Optional_PhaseCodeKind phase_;
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.Optional_PhaseCodeKind, openfmb.commonmodule.Optional_PhaseCodeKind.Builder, openfmb.commonmodule.Optional_PhaseCodeKindOrBuilder> phaseBuilder_;
    /**
     * <pre>
     * Phase code
     * </pre>
     *
     * <code>.commonmodule.Optional_PhaseCodeKind Phase = 3;</code>
     * @return Whether the phase field is set.
     */
    public boolean hasPhase() {
      return ((bitField0_ & 0x00000004) != 0);
    }
    /**
     * <pre>
     * Phase code
     * </pre>
     *
     * <code>.commonmodule.Optional_PhaseCodeKind Phase = 3;</code>
     * @return The phase.
     */
    public openfmb.commonmodule.Optional_PhaseCodeKind getPhase() {
      if (phaseBuilder_ == null) {
        return phase_ == null ? openfmb.commonmodule.Optional_PhaseCodeKind.getDefaultInstance() : phase_;
      } else {
        return phaseBuilder_.getMessage();
      }
    }
    /**
     * <pre>
     * Phase code
     * </pre>
     *
     * <code>.commonmodule.Optional_PhaseCodeKind Phase = 3;</code>
     */
    public Builder setPhase(openfmb.commonmodule.Optional_PhaseCodeKind value) {
      if (phaseBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        phase_ = value;
      } else {
        phaseBuilder_.setMessage(value);
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Phase code
     * </pre>
     *
     * <code>.commonmodule.Optional_PhaseCodeKind Phase = 3;</code>
     */
    public Builder setPhase(
        openfmb.commonmodule.Optional_PhaseCodeKind.Builder builderForValue) {
      if (phaseBuilder_ == null) {
        phase_ = builderForValue.build();
      } else {
        phaseBuilder_.setMessage(builderForValue.build());
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Phase code
     * </pre>
     *
     * <code>.commonmodule.Optional_PhaseCodeKind Phase = 3;</code>
     */
    public Builder mergePhase(openfmb.commonmodule.Optional_PhaseCodeKind value) {
      if (phaseBuilder_ == null) {
        if (((bitField0_ & 0x00000004) != 0) &&
          phase_ != null &&
          phase_ != openfmb.commonmodule.Optional_PhaseCodeKind.getDefaultInstance()) {
          getPhaseBuilder().mergeFrom(value);
        } else {
          phase_ = value;
        }
      } else {
        phaseBuilder_.mergeFrom(value);
      }
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Phase code
     * </pre>
     *
     * <code>.commonmodule.Optional_PhaseCodeKind Phase = 3;</code>
     */
    public Builder clearPhase() {
      bitField0_ = (bitField0_ & ~0x00000004);
      phase_ = null;
      if (phaseBuilder_ != null) {
        phaseBuilder_.dispose();
        phaseBuilder_ = null;
      }
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Phase code
     * </pre>
     *
     * <code>.commonmodule.Optional_PhaseCodeKind Phase = 3;</code>
     */
    public openfmb.commonmodule.Optional_PhaseCodeKind.Builder getPhaseBuilder() {
      bitField0_ |= 0x00000004;
      onChanged();
      return getPhaseFieldBuilder().getBuilder();
    }
    /**
     * <pre>
     * Phase code
     * </pre>
     *
     * <code>.commonmodule.Optional_PhaseCodeKind Phase = 3;</code>
     */
    public openfmb.commonmodule.Optional_PhaseCodeKindOrBuilder getPhaseOrBuilder() {
      if (phaseBuilder_ != null) {
        return phaseBuilder_.getMessageOrBuilder();
      } else {
        return phase_ == null ?
            openfmb.commonmodule.Optional_PhaseCodeKind.getDefaultInstance() : phase_;
      }
    }
    /**
     * <pre>
     * Phase code
     * </pre>
     *
     * <code>.commonmodule.Optional_PhaseCodeKind Phase = 3;</code>
     */
    private com.google.protobuf.SingleFieldBuilderV3<
        openfmb.commonmodule.Optional_PhaseCodeKind, openfmb.commonmodule.Optional_PhaseCodeKind.Builder, openfmb.commonmodule.Optional_PhaseCodeKindOrBuilder> 
        getPhaseFieldBuilder() {
      if (phaseBuilder_ == null) {
        phaseBuilder_ = new com.google.protobuf.SingleFieldBuilderV3<
            openfmb.commonmodule.Optional_PhaseCodeKind, openfmb.commonmodule.Optional_PhaseCodeKind.Builder, openfmb.commonmodule.Optional_PhaseCodeKindOrBuilder>(
                getPhase(),
                getParentForChildren(),
                isClean());
        phase_ = null;
      }
      return phaseBuilder_;
    }
    @java.lang.Override
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:commonmodule.BooleanEventAndStatusGGIO)
  }

  // @@protoc_insertion_point(class_scope:commonmodule.BooleanEventAndStatusGGIO)
  private static final openfmb.commonmodule.BooleanEventAndStatusGGIO DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new openfmb.commonmodule.BooleanEventAndStatusGGIO();
  }

  public static openfmb.commonmodule.BooleanEventAndStatusGGIO getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<BooleanEventAndStatusGGIO>
      PARSER = new com.google.protobuf.AbstractParser<BooleanEventAndStatusGGIO>() {
    @java.lang.Override
    public BooleanEventAndStatusGGIO parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      Builder builder = newBuilder();
      try {
        builder.mergeFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(builder.buildPartial());
      } catch (com.google.protobuf.UninitializedMessageException e) {
        throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(e)
            .setUnfinishedMessage(builder.buildPartial());
      }
      return builder.buildPartial();
    }
  };

  public static com.google.protobuf.Parser<BooleanEventAndStatusGGIO> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<BooleanEventAndStatusGGIO> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public openfmb.commonmodule.BooleanEventAndStatusGGIO getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

